;
;
;

org 100h ; ax=bx=0 si=0x100 sp=di=-2

  jmp S     ; [si]=C:3.50023913
  db 0x60
C320 dw 320 ; 0x40,1
;C4_5 dd 4.5
C4_5 equ $-2
  db 0x90, 0x40
;C2PIdivN dd 0.785398163  ; 2π/8
;C2PIdivN dd 0.897597901  ; 2π/7
;C2PIdivN dd 1.047197551  ; 2π/6
;C2PIdivN dd 1.25663706  ; 2π/5
C2PIdivN equ $-2
  db 0xa1, 0x3f ; 1.259, good enough

%define W(x) word[byte si-100h+x]
%define D(x) dword[byte si-100h+x]

S push 0xa000
  pop es
  mov al,13h  ; 320x200
  int 10h
M:
X cwd         ; dx=0
  mov ax,di
  div W(C320)

  sub dx,160  ; dx=X  ; -160..160
CROT equ $-2
  sub ax,100  ; ax=Y  ; -100..100
  pusha   ;[bx-10 -8 -6 -4]
          ;    bx dx cx ax
          ;       X  t  Y
  fild word[bx-4]
  fmul st0        ; x²
  fild word[bx-8]
  fmul st0        ; y² x²
  faddp           ; x²+y²
  fsqrt           ; r=√(x²+y²)      ; 0..100 vertically

  fild word[bx-8]
  fild word[bx-4]
  fpatan          ; a=atan2(x,y) r  ; -π..π
  
;  and ch,7  ; 00000abc
  shl ch,6  ; cf=a sf=b pf=b^c
  jnc C

;  push bx
;  mov bx,0x103
;  and bl,ch
;  mov bl,[byte bx+JUMP-100h]
;  jmp bx

;  fild word[bx-6]  ; slowly rotate: a+=t/320
;  fidiv W(CROT)
;  faddp

;N-gon / star / sun
A jns B
  fdiv D(C2PIdivN)  ; a/Q r           ; Q = 2π/N
F fist word[bp+si]
  fisub word[bp+si] ; fract(a/Q)-0.5 r
  jnp E
  fadd st0        ; Star
E fmul D(C2PIdivN)  ; s=Q*(fract(a/Q)-0.5) r
  fcos
  jmp K             ; R=r*cos(s)

;Cogwheel: C / (C + sin(sin(n*a) + π/4));
B fmul dword[si]  ; Cogwheel (7 points)
  jnp F           ; Sun (22 points)
  fadd st0
  fcos
  fadd dword[si]
  jmp J

;Clover: C / (C - cos(4.5 * sin(2a)));
C jp G
  jns D
  fadd st0
  fsin

;Flower with 9 petals
G fmul D(C4_5)
  fcos
  fchs
  js H
  fabs
H jmp I

;Heart: C / (C + sin(2|a| + C))
D fabs            ; |a| r
  fadd st0        ; 2|a| r
J fadd dword[si]  ; s=2|a|+C r
  fsin  
I fadd dword[si]
  fdivr dword[si]  ; R=r*C/(C+sin(s))
K fmulp

P fistp word[bx-4] ; pushed ax=a
  popa

  add ax,cx
  shr ax,5        ; ah<8
  and al,1
  stosb

  test di,di
  jnz X

  dec cx  ; t++
;  dec cx  ; t++
;  dec cx  ; t++
;  dec cx  ; t++

  mov dx,0x3da  ; vsync
V in al,dx
  test al,8
  jz V

  in al,60h
  cmp al,1
  jnz M
  ret
