;
;
;

org 100h ; ax=bx=0 si=0x100 sp=di=-2


; 55                push bp
; 3F                aas
; 5F                pop di
; 40                inc ax
; 01904086          add [bx+si-0x79c0],dx
; 3F                aas

;  jmp S     ; [si]=C:3.50023913
;C5_6 dd 0.833333333333
C5_6 equ $-2
  db 0x55,0x3F
  db 0x5F
C320 dw 320 ; 0x40,1
;C4_5 dd 4.5
C4_5 equ $-2
  db 0x90, 0x40
;C2PIdivN dd 0.785398163  ; 2π/8
;C2PIdivN dd 0.897597901  ; 2π/7
;C2PIdivN dd 1.047197551  ; 2π/6
;C2PIdivN dd 1.25663706  ; 2π/5
;C2PIdiv5 equ $-2
;  db 0xa1, 0x3f ; 1.259, good enough
C2PIdiv6 equ $-2
  db 0x86, 0x3f ; 1.04884529, good enough

%define W(x) word[byte si-100h+x]
%define D(x) dword[byte si-100h+x]

S xor cx,cx
  push 0xa000-640/16  ; hide top two rows
C7: pop es
  mov fs,[si]
  mov al,13h  ; 320x200
  int 10h

M inc cx  ; t++

X ;xor dx,dx;
  cwd         ; dx=0
  mov ax,di
  div W(C320)

  sub dx,160  ; dx=X  ; -160..160
CROT equ $-2
  sub ax,100  ; ax=Y  ; -100..100
  pusha   ;[bx-10 -8 -6 -4]
          ;    bx dx cx ax
          ;       X  t  Y
  fild word[bx-4]
  fmul st0        ; x²
  fild word[bx-8]
  fmul st0        ; y² x²
  faddp           ; x²+y²
  fsqrt           ; r=√(x²+y²)      ; 0..100 vertically

  fild word[bx-8]
  fild word[bx-4]
  fpatan          ; a=atan2(x,y) r  ; -π..π

;  and ch,7  ; 00000abc
  shl ch,6  ; cf=a sf=b pf=b^c
  jnc C

;Clover: C / (C - cos(4.5 sin(2a)));
  jnp G
  jns D
  fadd st0
  fsin

;Flower with 9 petals / butterfly
G fmul D(C4_5)
  fcos
  fchs
  js I
  fabs
  jmp I

;Heart: C / (C + sin(|2a| + C))
D fadd st0        ; 2a r
  fabs            ; |2a| r
J fadd dword[si]  ; s=|2a|+C r
  fsin
I fadd dword[si]
  fdivr dword[si]  ; R=r*C/(C+sin(s))
K fmulp

P fistp word[bx-4] ; pushed ax=a
  popa

  pusha

  mov bl,7
  and bl,ch
  imul bx,3

  sub al,cl
  test cl,0x10
  jz PZ
  add al,8
PZ
  shr al,6

  lea ax,[byte bx+32+24+24+24+19+24]
  jnc Y
  add al,72
Y:

  mov bx,-640
  mov [fs:di],al
YL:
  cmp al,[fs:di+bx]
  jae Z
  sub al,48
Z:
  sar bx,8
  jnp YL

  stosb
  popa

  inc di
  jnz X

  
  mov dx,0x3da  ; vsync
V in al,dx
  test al,8
  jz V
  
  pusha
  push cx
  
  mov bx,7<<5
  and bx,cx
  shr bx,5

  mov si,MIDI
  mov dl,0x31   ; MIDI control port
  outsb         ; uart
  dec dx        ; MIDI data port
  
  test cl,15
  jnz NOCHORD
  mov cx,9
  rep outsb
  
  mov cl,3
  mov bl,[bx+si+CHORDS-CHORD_NOTES]
PLAY_CHORD:
  lodsb
  add al,bl
  mul byte[C12] ; 0=E 1=F 2=G ...
  div byte[C7]
  add al,36
  out dx,al
  mov al,0x7f
  out dx,al
  loop PLAY_CHORD

NOCHORD:
  pop cx

  test cl,7
  jnz NOMELODY

  mov al,0x90
  out dx,al
  mov bx,15<<3
  and bx,cx
  shr bx,3
  mov al,12  
C12 equ $-1
  mul byte[bx+MELODY]
  div byte[C7]
  add al,48
  out dx,al
  mov al,0x80
  out dx,al

NOMELODY:
  popa

  in al,60h
  cmp al,1
  jnz M
  ret

C fild word[bx-6]
  fidiv W(C320)
  faddp

;  push bx
;  mov bx,0x103
;  and bl,ch
;  mov bl,[byte bx+JUMP-100h]
;  jmp bx

;  fild word[bx-6]  ; slowly rotate: a+=t/320
;  fidiv W(CROT)
;  faddp

;N-gon / star / sun
A jnp B
  fdiv D(C2PIdiv6)  ; a/Q r           ; Q = 2π/N
  jns F
  fmul D(C5_6)
F fist word[bp+si]
  fisub word[bp+si] ; fract(a/Q)-0.5 r
  jns E
  fadd st0        ; Star
E fmul D(C2PIdiv6)  ; s=Q*(fract(a/Q)-0.5) r
  fcos
  jmp K             ; R=r*cos(s)

;Cogwheel: C / (C + sin(sin(7a) + 2C)) ; 2C-2π ≈ π/4
B fmul dword[si]  ; Cogwheel (7 points)
  jns F           ; Sun (22 points)
  fadd st0
  fcos
  fadd dword[si]
  jmp J

MIDI:

  db 0x3f ; uart

  db 0x99, 36, 0x7f ; bass drum

  db 0xc1, 50       ; ch1 instrument
  db 0xb1, 123, 0   ;      notes off
  db 0x91
  
  ; the following will be *12/7
CHORD_NOTES:
  %define TR 3
  db 0+TR,4+TR,7+2+TR

  db 0x90  ; running piano melody

CHORDS:
  db 0,1,1,1,3,3,2,2

MELODY:
  db TR+0,TR+1,TR+2,TR+3,TR+4,TR+5,TR+6,TR+7,TR+8,TR+9,TR+10,TR+11,TR+12,TR+13,TR+14,TR+15
